/*
 * com/ngon/math/Math2D.java
 * Victor Liu > mailto:victor@n-gon.com
 *
 * Copyright (C) 2004 Victor Liu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.ngon.math;

import java.awt.Point;

/**
 * class Math2D
 */
final public class Math2D {
    
    static public double angleBetween(Point v1, Point v2) {
        if ((v1.x == 0 && v1.y == 0) || (v2.x == 0 && v2.y == 0)) {
            return 0;
        }
        double a1, a2;
        if (v1.y == 0) {
            if (v1.x < 0) {
                a1 = -Math.PI;
            } else {
                a1 = 0;
            }
        } else {
            a1 = Math.atan2(v1.y, v1.x);
        }
        if (v2.y == 0) {
            if (v2.x < 0) {
                a2 = -Math.PI;
            } else {
                a2 = 0;
            }
        } else {
            a2 = Math.atan2(v2.y, v2.x);
        }
        double arc = a2 - a1;
        if (arc >= Math.PI) {
            arc -= 2 * Math.PI;
        } else if (arc < -Math.PI) {
            arc += 2 * Math.PI;
        }
        return (arc * 180.0 / Math.PI);
    }
}

